$SYJDD::numberofclasses = 0;		//this is actually just a maximum count, not an accurate count
$SYJDD::classpicksforlife = 1;

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs")) 
{ 
	if(!$RTB::RTBR_ServerControl_Hook) 
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs"); 
	RTB_registerPref("Max class switches per life","Classes","$SYJDD::classpicksforlife","int 1 100","Script_Classes",1,0,0);
}

function saveclasses()
{
	export("$SYJDD::*","config/server/classes.cs");
}

function loadclasses()
{
	exec("config/server/classes.cs");
}

function getidfromclassname(%classname)  //auxillery function to get a number from a name
{
	if($SYJDD::numberofclasses < 1)  //if there are no classes yet
		return -1;		 //-1 is the code for 'no class by that name found'

	for(%a = 0; %a<$SYJDD::numberofclasses; %a++)
	{
		if($SYJDD::classes::names[%a] $= %classname && $SYJDD::classused[%a])
			return %a;
	}
	
	return -1;			//this part of the function is only reached if it didn't find anything, so return -1
}

function serverCmdlistclasses(%client)
{
	for(%a = 0; %a<$SYJDD::numberofclasses; %a++)
	{
		if($SYJDD::classused[%a])
			messageclient(%client,'',"Class" SPC %a SPC $SYJDD::classes::names[%a]);
	}
}

function serverCmdlistclassitems(%client,%name)
{
	if(getidfromclassname(%name) == -1)
		messageclient(%client,'',"No class by that name exists.");
	else
	{
		for(%a = 0; %a<5; %a++)
		{
			%itemname = $SYJDD::itemlayout[getidfromclassname(%name),%a];
			if(nametoID(%itemname) < 1)
				messageclient(%client,'',"Slot" SPC %a SPC "has no item.");
			else
				messageclient(%client,'',"Slot" SPC %a SPC "has item" SPC %itemname);
		}
	}
}

function serverCmdcreateclass(%client,%classname)	//creating a new class
{
	messageclient(%client,'',"Attempting to create class.");
	if(%client.isSuperAdmin)
	{
		%ccy = false;					//class created yet (ccy)
		if($SYJDD::numberofclasses > 0)
		{
			for(%a = 0; %a<$SYJDD::numberofclasses; %a++)	//you apparently can have two classes by the same name, but that could cause problems
			{
				if(!$SYJDD::classused[%a])
				{
					$SYJDD::classes::names[%a] = %classname;
					$SYJDD::classused[%a] = true;
					%ccy = true;
				}
			}
		}	
		if(!%ccy)
		{
			$SYJDD::classes::names[$SYJDD::numberofclasses] = %classname;
			$SYJDD::classused[$SYJDD::numberofclasses] = true;
			$SYJDD::numberofclasses++;
		}
	}
		else messageclient(%client,'',"You need to be super admin to do this.");
}

function serverCmdremoveclass(%client,%classname)
{
	messageclient(%client,'',"Attempting to remove class.");
	if(%client.isSuperAdmin)
	{
		%classid = getidfromclassname(%classname);
		if(%classid == -1)
			messageclient(%client,'',"There is no class by that name.");
		else
		{
			$SYJDD::classused[%classid] = false;
			$SYJDD::classes::names[%classid] = "";
			echo(%classid);
			for(%a = 0; %a<5; %a++)
				$SYJDD::itemlayout[%classid,%a] = "none";
		}
	}
	else
		messageclient(%client,'',"You must be super admin to do this.");
}

function servercmdsetclassdatablock(%client,%classname,%datablock)
{
	if(getidfromclassname(%classname) == -1)
	{
		messageclient(%client,'',"No class by that name exists.");
		return;
	}

	if(%client.isSuperAdmin)
	{
		if(%datablock $= "none")
		{
			messageclient(%client,'',"Class datablock removed.");
			$SYJDD::classusedatablock[getidfromclassname(%classname)] = false;	
		}
		else if(nametoID(%datablock) == -1)
			messageclient(%client,'',"No datablock by that name exists.");
		else
		{
			messageclient(%client,'',"Class datablock set.");
			$SYJDD::classusedatablock[getidfromclassname(%classname)] = true;
			$SYJDD::classdatablock[getidfromclassname(%classname)] = %datablock;
		}
	}
	else messageclient(%client,'',"You're not an super admin, you can't do that.");
}

function servercmdsetclasspoints(%client,%classname,%datablock)
{
	if(getidfromclassname(%classname) == -1)
	{
		messageclient(%client,'',"No class by that name exists.");
		return;
	}

	if(%client.isSuperAdmin)
	{
		if(%datablock < 1)
		{
			messageclient(%client,'',"Class no longer requires points.");
			$SYJDD::classusepoints[getidfromclassname(%classname)] = false;	
		}
		else
		{
			messageclient(%client,'',"Class points required set.");
			$SYJDD::classusepoints[getidfromclassname(%classname)] = true;
			$SYJDD::classpoints[getidfromclassname(%classname)] = %datablock;
		}
	}
	else messageclient(%client,'',"You're not an super admin, you can't do that.");
}

function serverCmdsetclassweapon(%client,%classname,%slot,%weaponname)	//the actual script name of the item, not it's ui name
{									//maybe I should find a way to allow ui names too
	messageclient(%client,'',"Attempting to set class weapon.");
	if(%client.isSuperAdmin)
	{
		if(getidfromclassname(%classname) == -1) //if the class dosn't exist just end the function
		{	
			messageclient(%client,'',"There is no class by that name.");
			return;
		}

		if(nametoID(%weaponname) == -1)
			messageclient(%client,'',"This weapon does not exist currently, setting anyway.");
		//allow it to continue because maybe this weapon will become available later
		//I don't want to force resets of data because the item just happened not to be available at that time

		if(%slot > -1 && %slot < 5)	//this dosn't account for those extended inventory types for now
			$SYJDD::itemlayout[getidfromclassname(%classname),%slot] = %weaponname;
		else
			messageclient(%client,'',"Invalid slot number, currently this mod only works with standard inventory set ups.");
	}
}

function serverCmdsetclassfrominventory(%client,%class)
{
	for(%a = 0; %a<5; %a++)
		serverCmdsetclassweapon(%client,%class,%a,%client.player.tool[%a].getName());
}

function serverCmdchooseclass(%client,%name)
{
	messageclient(%client,'',"Attempting to choose class.");
	if(getidfromclassname(%name) < 0)
		messageclient(%client,'',"No class with this NAME exists.");
	else
	{
	if($SYJDD::classusepoints[getidfromclassname(%name)])
	{
	if(!(%client.score < $SYJDD::classpoints[getidfromclassname(%name)]))
	{
	if(%client.haschosenclass > $SYJDD::classpicksforlife-1)
		messageclient(%client,'',"You have already picked a class this lifetime.");
	else
	{
		GiveItems(%client.name,%name);
		%client.haschosenclass++;
		$SYJDD::timesclasspicked[getidfromclassname(%name)]++;
	
		if($SYJDD::classusedatablock[getidfromclassname(%name)])
			%client.player.changeDatablock($SYJDD::classdatablock[getidfromclassname(%name)]);
	}
	}
	else messageclient(%client,'',"This class requires" SPC $SYJDD::classpoints[getidfromclassname(%name)] SPC "points which you do not have.");
	}
	else
	{
	if(%client.haschosenclass > $SYJDD::classpicksforlife-1)
		messageclient(%client,'',"You have already picked a class this lifetime.");
	else
	{
		GiveItems(%client.name,%name);
		%client.haschosenclass++;
		$SYJDD::timesclasspicked[getidfromclassname(%name)]++;
	
		if($SYJDD::classusedatablock[getidfromclassname(%name)])
		{
			echo($SYJDD::classdatablock[getidfromclassname(%name)]);
			%client.player.changeDatablock($SYJDD::classdatablock[getidfromclassname(%name)]);
		}
	}

	}
	}
}

deactivatepackage(syj_classes_main);
package syj_classes_main
{
	function GameConnection::createPlayer(%this,%transform)
	{
		Parent::createPlayer(%this,%transform);
		%this.haschosenclass = 0;
		%this.gre = false;
	}
};
activatepackage(syj_classes_main);


function GiveItems(%name,%class)
{
	%cl = findclientbyname(%name);
	if(isObject(%cl))                  //if there's a player by that name
	{
		if(getidfromclassname(%class) != -1)    //and the class chosen exists
		{
			for(%a = 0; %a<5; %a++)			//for   all 5 slots fill their items
			{
				%cl.player.tool[%a] = nametoID($SYJDD::itemlayout[getidfromclassname(%class),%a]);
				%toolid = nametoID($SYJDD::itemlayout[getidfromclassname(%class),%a]);
				if(%toolid < 0)			//if it hasn't been set, or has been set to a non-existant weapon, just default to nothing
					%toolid = 0;
				messageClient(%cl, 'MsgItemPickup', '', %a, %toolid);
			}
		}
	}
}

function servercmdrequestclassitemlist(%client,%class)
{
	if(getidfromclassname(%class) == -1)
	{
		messageclient(%client,'',"There is no class by this name.");
		return;
	}

	%a = $SYJDD::itemlayout[getidfromclassname(%class),0].uiName;
	%b = $SYJDD::itemlayout[getidfromclassname(%class),1].uiName;
	%c = $SYJDD::itemlayout[getidfromclassname(%class),2].uiName;
	%d = $SYJDD::itemlayout[getidfromclassname(%class),3].uiName;
	%e = $SYJDD::itemlayout[getidfromclassname(%class),4].uiName;
	if($SYJDD::classusedatablock[getidfromclassname(%class)])
	%f = $SYJDD::classdatablock[getidfromclassname(%class)].uiname;
	else
	%f = 0;
	%g = $SYJDD::classpoints[getidfromclassname(%class)];

	commandtoclient(%client,'reciveclassitemlist',%class,%a,%b,%c,%d,%e,%f,%g);
}

function servercmdeditclass(%client,%class)
{
	if(getidfromclassname(%class) == -1)
	{
		messageclient(%client,'',"There is no class by this name.");
		return;
	}
	
	commandtoclient(%client,'openclassitemgui',%class);
}

function servercmdsyjeditclass(%client,%class,%a,%b,%c,%d,%e,%f,%g)
{
	if(getidfromclassname(%class) == -1)
	{
		messageclient(%client,'',"There is no class by this name.");
		return;
	}

	if(!%client.isSuperAdmin)
	{
		messageclient(%client,'',"You must be a super admin to do this.");
		return;
	}
	if(%a != 0)
	$SYJDD::itemlayout[getidfromclassname(%class),0] = %a.getname();
	else
	$SYJDD::itemlayout[getidfromclassname(%class),0] = 0;
	if(%b != 0)
	$SYJDD::itemlayout[getidfromclassname(%class),1] = %b.getname();
	else
	$SYJDD::itemlayout[getidfromclassname(%class),1] = 0;
	if(%c != 0)
	$SYJDD::itemlayout[getidfromclassname(%class),2] = %c.getname();
	else
	$SYJDD::itemlayout[getidfromclassname(%class),2] = 0;
	if(%d != 0)
	$SYJDD::itemlayout[getidfromclassname(%class),3] = %d.getname();
	else
	$SYJDD::itemlayout[getidfromclassname(%class),3] = 0;
	if(%e != 0)
	$SYJDD::itemlayout[getidfromclassname(%class),4] = %e.getname();
	else
	$SYJDD::itemlayout[getidfromclassname(%class),4] = 0;
	if(%f == 0)
		$SYJDD::classusedatablock[getidfromclassname(%classname)] = false;
	else
	{
		$SYJDD::classusedatablock[getidfromclassname(%class)] = true;
		$SYJDD::classdatablock[getidfromclassname(%class)] = %f.getname();
	}
	
	$SYJDD::classpoints[getidfromclassname(%class)] = %g;
	
	if(%g < 1)
		$SYJDD::classusepoints[getidfromclassname(%class)] = false;	
	else
		$SYJDD::classusepoints[getidfromclassname(%class)] = true;

}

function servercmdXgetclasslist(%client,%class)
{
	commandtoclient(%client,'classlisting',$SYJDD::numberofclasses
	,$SYJDD::classes::names[0]
	,$SYJDD::classes::names[1]
	,$SYJDD::classes::names[2]
	,$SYJDD::classes::names[3]
	,$SYJDD::classes::names[4]
	,$SYJDD::classes::names[5]
	,$SYJDD::classes::names[6]
	,$SYJDD::classes::names[7]
	,$SYJDD::classes::names[8]
	,$SYJDD::classes::names[9]
	,$SYJDD::classes::names[10]
	,$SYJDD::classes::names[11]
	,$SYJDD::classes::names[12]
	,$SYJDD::classes::names[13]
	,$SYJDD::classes::names[14]
	,$SYJDD::classes::names[15]
	,$SYJDD::classes::names[16]
	,$SYJDD::classes::names[17]
	,$SYJDD::classes::names[18]
	,$SYJDD::classes::names[19]
	);
}

function servercmdXgetclassitems(%client,%class)
{
	if(getidfromclassname(%class) == -1)
		return;

	commandtoclient(%client,'classitems',getidfromclassname(%class)
	,nametoID($SYJDD::itemlayout[getidfromclassname(%class),0]).uiname
	,nametoID($SYJDD::itemlayout[getidfromclassname(%class),1]).uiname
	,nametoID($SYJDD::itemlayout[getidfromclassname(%class),2]).uiname
	,nametoID($SYJDD::itemlayout[getidfromclassname(%class),3]).uiname
	,nametoID($SYJDD::itemlayout[getidfromclassname(%class),4]).uiname
	);
}